import requests
import json

def make_post_b2b_request(endpoint, token, order_id, status):
    headers = {
        'Authorization': f'Bearer {token}',
        'Accept': 'application/json',
        'Content-Type': 'application/json' 
    }
    payload = {
        "type": 2,
        "comment": order_id + " STATUS: " + status
    }

    response = requests.post(endpoint.format(apilo_id), headers=headers, json=payload)

    if response.status_code == 200 or response.status_code == 201:
        try:
            return response.json()  
        except ValueError as e:
            return f"JSON decoding error: {str(e)}"
    else:
        return f"Request failed with status code: {response.status_code}\n{response.text}" 

def create_shipment_tracking(endpoint, token, tracking):
    headers = {
        'Authorization': f'Bearer {token}',
        'Accept': 'application/json',
        'Content-Type': 'application/json' 
    }

    trackings = tracking.split(',')

    current_id_external = 1

    for single_tracking in trackings:
        payload = {
            "idExternal": str(current_id_external),
            "tracking": single_tracking.strip(),
            "carrierProviderId": 25
        }

        response = requests.post(endpoint.format(apilo_id), headers=headers, json=payload)
        print(response.text)

        current_id_external += 1

    return

def send_tracking_paymentdelivery(endpoint, token, order_id, tracking):
    headers = {
        'Authorization': f'Bearer {token}',
        'Accept': 'application/json',
        'Content-Type': 'application/json' 
    }

    payload = {
        "type": 2,
        "comment":"Przesyłka pobraniowa: "+order_id + " Tracking: " + tracking
    }

    response = requests.post(endpoint.format(apilo_id), headers=headers, json=payload)
    print(response.text)

    return


if __name__ == "__main__":
    with open('/usr/home/shumeeshumee/domains/python.shumeeshumee.usermd.net/public_python/Apilo_token_refresher/response.json', 'r') as file:
        response_data = json.load(file)
        access_token = response_data.get('accessToken', '')

    with open('output_new.json', 'r') as file:
        orders = json.load(file)

    api_endpoint_note = 'https://shumee.apilo.com/rest/api/orders/{}/note/'
    api_endpoint_shipping = 'https://shumee.apilo.com/rest/api/orders/{}/shipment/'

    for order in orders:
        order_id = order.get('id')
        change_id = order.get('change_id')
        status = order.get('status_order_name')
        tracking = order.get('shipping_tracking')
        apilo_id = order.get('comments_customer')

        if change_id == 1:
            result = make_post_b2b_request(api_endpoint_note, access_token, order_id, status)
            print(result)
        elif change_id == 2:
            result2 = make_post_b2b_request(api_endpoint_note, access_token, order_id, status)
            print(result2)
        elif change_id == 3:
            result3 = create_shipment_tracking(api_endpoint_shipping, access_token, tracking)
            print(result3)
        elif change_id == 4:
            result4 = send_tracking_paymentdelivery(api_endpoint_note, access_token, order_id, tracking)
            print(result4)
